routes/web.php
<?php

use App\Http\Controllers\InvoiceController;
use App\Http\Controllers\Pages\HomePageController;
use App\Http\Controllers\Pages\InvoicePageController;
use App\Http\Controllers\Pages\SettingPageController;
use App\Http\Controllers\Pages\SubscriberPageController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;
use SimpleSoftwareIO\QrCode\Facades\QrCode;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('test', function (){
    return QrCode::generate('Make me into a QrCode!');
});

Route::get('/', [HomePageController::class, 'index'])->name('welcome');
Route::get('/ztracene-heslo', [HomePageController::class, 'lostPassword'])->name('lost-password');
Route::get('/kontakt', [HomePageController::class, 'contact'])->name('contact');

Route::group(['middleware' => 'auth'], function () {
    Route::get('/faktury', [InvoicePageController::class, 'index'])->name('invoiceList');
    Route::get('/faktura', [InvoicePageController::class, 'createInvoice'])->name('invoiceCreate');
    Route::get('/faktura/{id}/edit', [InvoicePageController::class, 'editInvoice'])->name('invoiceEdit');
    Route::get('/faktura/{id}/copy', [InvoicePageController::class, 'copyInvoice'])->name('invoiceCopy');
    Route::get('/faktura/{id}/delete', [InvoicePageController::class, 'destroyInvoice'])->name('invoiceDelete');
    Route::get('/faktura/{id}/download', [InvoicePageController::class, 'downloadInvoice'])->name('invoiceDownload');
    Route::post('/send-invoice', [InvoiceController::class, 'sendInvoice']);

    Route::get('/odberatele', [SubscriberPageController::class, 'index'])->name('subscribers');

    Route::get('/nastaveni', [SettingPageController::class, 'index'])->name('setting');
    Route::post('/nastaveni-update', [SettingPageController::class, 'updateSetting']);

    // @TODO předělat do api
    Route::post('api/get-invoice-data', [InvoiceController::class, 'getInvoice'])->name('get.invoice-data');
    Route::post('api/get-subscriber-data', [InvoiceController::class, 'getSubscriber'])->name('get.subscriber-data');
});

Auth::routes();

app/Models/Invoice.php
<?php

declare(strict_types=1);

namespace App\Models;

use Barryvdh\DomPDF\Facade as PdfFacade;
use Barryvdh\DomPDF\PDF;
use Carbon\Carbon;
use Cviebrock\EloquentSluggable\Sluggable;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\SoftDeletes;

class Invoice extends Model
{
    use HasFactory;
    use Sluggable;
    use SoftDeletes;

    private const PDF_PATH = '/invoice_pdf/';
    private const PDF_VIEW = 'pdf';

    public const INVOICE_CREATE = 'create';
    public const INVOICE_EDIT = 'edit';
    public const INVOICE_COPY = 'copy';

    public const MONTH_DUE_DATE_ID = 5;
    public const CUSTOM_DUE_DATE_ID = 6;

    public const INVOICE_TYPES = [
        1 => 'Faktura bez DPH (nejsem plátce DPH)',
//        2 => 'Zálohová faktura'
    ];

    public const PAYMENT_TYPES = [
        1 => 'Bankovní převod',
//        2 => 'Kartou',
//        3 => 'Hotovost',
//        4 => 'Dobírka',
    ];

    public const DUE_DATE_TYPES = [
        1 => 'Dnes',
        2 => 'Týden',
        3 => '10 dní',
        4 => '14 dní',
        self::MONTH_DUE_DATE_ID => 'Měsíc',
        self::CUSTOM_DUE_DATE_ID => 'Vlastní',
    ];

    public const ADD_DAYS_BY_DUE_DATE_TYPE = [
        1 => 0,
        2 => 7,
        3 => 10,
        4 => 14,
    ];

    public const DESIGN_TYPES = [
        1 => 'Jednoduchý',
        2 => 'Moderní'
    ];

    public const ROUNDING_TYPES = [
        1 => 'Žádné',
        2 => 'Nejbližších 10 haléřů',
        3 => 'Celá čísla'
    ];

    public const SESSION_BY_EVENT = [
        self::INVOICE_CREATE => [
            'type' => 'success',
            'message' => 'Faktura byla vytvořena'
        ],
        self::INVOICE_EDIT => [
            'type' => 'success',
            'message' => 'Faktura byla aktualizována'
        ],
        self::INVOICE_COPY => [
            'type' => 'success',
            'message' => 'Faktura byla vytvořena'
        ],
    ];

    protected $guarded = [];

    protected $casts = [
        'date_of_issue' => 'date',
        'due_date' => 'date'
    ];

    /**
     * Return the sluggable configuration array for this model.
     *
     * @return array
     */
    public function sluggable(): array
    {
        return [
            'slug' => [
                'source' => 'name'
            ]
        ];
    }

    /**
     * @return string
     */
    public function getInvoiceTypeAttribute(): string
    {
        return self::INVOICE_TYPES[$this->type_id];
    }

    /**
     * @return string
     */
    public function getInvoicePaymentTypeAttribute(): string
    {
        return self::PAYMENT_TYPES[$this->type_of_payment];
    }

    /**
     * @return string
     */
    public function getFullPdfPath(): string
    {
        return public_path() . self::PDF_PATH . $this->user_id . '/';
    }

    /**
     * @param string $entryDate
     * @param int $dueDateType
     *
     * @return Carbon
     */
    public static function getDueDateByDueDateType(string $entryDate, int $dueDateType): Carbon
    {
        if(self::MONTH_DUE_DATE_ID === $dueDateType){
            return Carbon::parse($entryDate)->addMonth();
        }

        return Carbon::parse($entryDate)->addDays(self::ADD_DAYS_BY_DUE_DATE_TYPE[$dueDateType]);
    }

    /**
     * @return BelongsTo
     */
    public function invoiceSubscriber(): BelongsTo
    {
        return $this->belongsTo(InvoiceSubscriber::class);
    }

    /**
     * @return HasMany
     */
    public function invoiceLists(): HasMany
    {
        return $this->hasMany(InvoiceList::class);
    }

    /**
     * @param string $view
     * @return PDF
     */
    public function preparePdf($view = self::PDF_VIEW): PDF
    {
        $invoice = $this;
        return PdfFacade::loadView($view, compact('invoice'));
    }
}

resources/views/contact.blade.php
@extends('layouts.page')

@section('title', '| Kontakt')

@section('content')

    <div class="container">
        <div class="text-center mb-4 mt-4">
            <h3 class="font-weight-bolder text-uppercase">Kontakt</h3>
        </div>
        <div class="card mb-4 border-0 mr-auto ml-auto">
            <div class="card-body">
                <div class="row">
                    <div class="col-md-6">
                        <h5>Vaše zpětná vazba je pro nás důložitá!</h5>
                        <br>
                        <p>
                            V případě že nám chcete cokoliv zdělit, použijte prosím kontaktní formulář. <br>
                            Oceníme také jakýkoliv nápad na zlepšení, či report případné chyby.
                        </p>

                        <p>
                            O schválení vaší PDF šablony nám psát nemusíte. Všechny požadavky vyřidíme v nejbližší době.
                        </p>

                        <p>
                            V případě že by jste měli zájem naš projekt podpořit. Pokračujte prosím zde <a href="#">Donate</a>
                        </p>

                    </div>
                    <div class="col-md-6">
                        <form method="POST" action="">
                            @csrf
                            {!! Honeypot::generate('my_name', 'my_time') !!}
                            <div class="form-group">
                                <label for="loginEmail">* E-mail</label>
                                <input type="email" name="email" class="form-control @error('email') is-invalid @enderror"
                                       id="loginEmail" aria-describedby="emailHelp" value="{{ old('email') }}" required
                                       autocomplete="email" autofocus>
                                @error('email')
                                <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                            <div class="form-group">
                                <label for="subject">Předmět</label>
                                <input type="text" name="subject" class="form-control">
                            </div>
                            <div class="form-group">
                                <label for="subject">* Zpráva</label>
                                <textarea type="text" name="text" class="form-control" cols="" rows="4" required></textarea>
                                @error('text')
                                <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                            <button type="submit" class="btn btn-primary">Odeslat</button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>

@endsection

resources/views/list.blade.php
@extends('layouts.page')

@section('title', '| Přehled faktur')

@section('content')

    <div class="container">
        <div class="text-center mb-4 mt-4">
            <h3 class="font-weight-bolder text-uppercase mb-0">Vystavené faktury</h3>
        </div>

        @include('includes.invoice-alert')

        <div class="card mb-4 border-0 shadow-sm">
            <div class="card-body">
                <div class="d-flex justify-content-between">
                    <div class="d-flex">
                        <div class="dropdown">
                            <button class="btn btn-outline-dark dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                Hromadné akce
                            </button>
                            <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                                <a class="dropdown-item" href="#">Stáhnout faktury</a>
                                <a class="dropdown-item" href="#">Smazat faktury</a>
                                <a class="dropdown-item" href="#">Odeslat faktury</a>
                            </div>
                        </div>
                    </div>
                    <form>
                        <input class="form-control mr-sm-2" type="text" placeholder="Hledat" aria-label="Search">
                    </form>
                </div>
            </div>
                <table class="table table-striped mb-0">
                    <thead class="thead-dark">
                    <tr class="mb-4">
                        <th scope="col" class="text-center bg-primary border-0">
                            <div class="custom-control custom-checkbox">
                                <input type="checkbox" class="custom-control-input" id="invoice-id">
                                <label class="custom-control-label pointer" for="invoice-id"></label>
                            </div>
                        </th>
                        <th scope="col" class="bg-primary border-0">Číslo</th>
                        <th scope="col" class="bg-primary border-0">Oběratel</th>
                        <th scope="col" class="bg-primary border-0">Splatnost</th>
                        <th scope="col" class="bg-primary border-0">Typ faktury</th>
                        <th scope="col" class="bg-primary border-0">Částka</th>
                        <th scope="col" class="bg-primary border-0"></th>
                    </tr>
                    </thead>
                    <tbody>
                    @foreach($invoices as $key => $invoice)
                    <tr>
                        <td class="text-center">
                            <div class="custom-control custom-checkbox">
                                <input type="checkbox" class="custom-control-input invoice-checkbox" id="invoice-id-{{$key}}">
                                <label class="custom-control-label pointer" for="invoice-id-{{$key}}"></label>
                            </div>
                        </td>
                        <td>{{$invoice->reference_number}}</td>
                        <td>{{$invoice->invoiceSubscriber->name}}</td>
                        <td>{{$invoice->due_date->format('d.m.Y')}}</td>
                        <td>{{$invoice->invoice_type}}</td>
                        <td>@money($invoice->invoiceLists->sum('total_price')) Kč</td>
                        <td class="d-flex justify-content-center">
                            <a href="#" class="d-inline-block mr-1"><img src="{{asset('svg/email.svg')}}" class="card-body__action-icon" alt=""></a>
                            <a href="{{route('invoiceDownload', $invoice->id)}}" class="d-inline-block mr-1"><img src="{{asset('svg/download.svg')}}" class="card-body__action-icon" alt=""></a>
                            <a href="{{route('invoiceCopy', $invoice->id)}}" class="d-inline-block mr-1"><img src="{{asset('svg/copy.svg')}}" class="card-body__action-icon" alt=""></a>
                            <a href="{{route('invoiceEdit', $invoice->id)}}" class="d-inline-block mr-1"><img src="{{asset('svg/edit.svg')}}" class="card-body__action-icon" alt=""></a>
                            <a href="#" data-toggle="modal" data-target="#deleteModal-{{$key}}" class="d-inline-block"><img src="{{asset('svg/delete-black.svg')}}" class="card-body__action-icon" alt=""></a>
                        </td>
                    </tr>
                    <!-- Modal -->
                    <div class="modal fade" id="deleteModal-{{$key}}" tabindex="-1" role="dialog"  aria-hidden="true">
                        <div class="modal-dialog" role="document">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title" id="exampleModalLabel">Odstranit fakturu</h5>
                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                        <span aria-hidden="true">&times;</span>
                                    </button>
                                </div>
                                <div class="modal-body">
                                   Opravdu chcete odstranit fakturu?
                                </div>
                                <div class="modal-footer">
                                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Ne</button>
                                    <a href="{{route('invoiceDelete', $invoice->id)}}"><button type="button" class="btn btn-danger">Ano</button></a>
                                </div>
                            </div>
                        </div>
                    </div>
                    @endforeach
                </table>
            </div>
        </div>
        <div class="d-flex justify-content-center">
            <div class="pagination">
                {{$invoices->links()}}
            </div>
        </div>
    </div>

@endsection

@section('script')
    <script>
        document.addEventListener("DOMContentLoaded", function() {
            let mainCheckBox = document.querySelector("#invoice-id");
            let invoiceCheckboxes = document.querySelectorAll(".invoice-checkbox");
            mainCheckBox.addEventListener('click', () => {
                if(mainCheckBox.checked === true) {
                    invoiceCheckboxes.forEach(element => {
                        if(element.checked === true) {
                            return;
                        }
                        element.checked = true
                    })
                } else {
                    invoiceCheckboxes.forEach(element => {
                        if(element.checked === false) {
                            return;
                        }
                        element.checked = false
                    })
                }
            })
        });
    </script>
@endsection

resources/views/lost-password.blade.php
@extends('layouts.page')

@section('title', '| Reset hesla')

@section('content')

    <div class="container">
        <div class="text-center mb-4 mt-4">
            <h3 class="font-weight-bolder text-uppercase">Reset hesla</h3>
        </div>
        <div class="card mb-4 border-0 w-50 mr-auto ml-auto">
            <div class="card-body">
                <form method="POST" action="">
                    @csrf
                    {!! Honeypot::generate('my_name', 'my_time') !!}
                    <p>V případě že jste zapoměli heslo, zadejte váš e-mail. Zašleme Vám odkaz na jeho resetování.</p>
                    <div class="form-group">
                        <label for="loginEmail">* E-mail</label>
                        <input type="email" name="email" class="form-control @error('email') is-invalid @enderror"
                               id="loginEmail" aria-describedby="emailHelp" value="{{ old('email') }}" required
                               autocomplete="email" autofocus>
                        @error('email')
                        <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                        @enderror
                    </div>
                    <button type="submit" class="btn btn-primary">Odeslat</button>
                </form>
            </div>

            {{-- nastavení nového hesla --}}
            <div class="card-body">
                <p>Zadejte své nové heslo</p>
                <form method="POST" action="">
                    @csrf
                    {!! Honeypot::generate('my_name', 'my_time') !!}
                    <div class="form-group">
                        <label for="registrationPassword">* Heslo</label>
                        <input type="password" name="password"
                               class="form-control @error('password') is-invalid @enderror" id="registrationPassword"
                               required autocomplete="new-password">
                        @error('password')
                        <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                        @enderror
                    </div>
                    <div class="form-group">
                        <label for="registrationPasswordForCheck">* Heslo pro kontrolu</label>
                        <input type="password" name="password_confirmation" class="form-control"
                               id="registrationPasswordForCheck" required autocomplete="new-password">
                    </div>
                    <button type="submit" class="btn btn-primary">Odeslat</button>
                </form>
            </div>
        </div>
    </div>

@endsection

resources/views/pdf.blade.php
<html lang="cs">
<head>
    <title>Easy-faktura</title>

    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">

    <style type="text/css">

        body {
            font-family: DejaVu Sans, sans-serif;
            position: relative;
        }

        table {
            /*border-collapse: collapse;*/
            font-size: x-small;
            border-spacing: 0;
        }

        thead th {
            font-weight: normal;
        }

        .invoice-header-author p, .invoice-header-delivery p {
            margin: 0;
        }

        .invoice-header-number h3, .invoice-header-number h4 {
            margin: 0;
        }

        .vertical-align-bottom {
            vertical-align: bottom;
        }

        .vertical-align-top {
            vertical-align: top;
        }

        hr {
            margin-top: 20px;
            margin-bottom: 1px;
            opacity: 0.2;
        }

    </style>

</head>
<body>

<table width="100%">
    <tr class="vertical-align-bottom">
        <td valign="left" class="invoice-header-author">
            <p>{{$invoice->name}}</p>
            <p>{{$invoice->street}}</p>
            <p>{{$invoice->postcode}}, {{$invoice->city}}</p>
{{--            <p>{{$invoice->country->name}}</p>--}}
            <br>
            <p>IČO: {{$invoice->ico}}</p>
            <p>Neplátce DPH </p>
        </td>
        <td align="right" class="invoice-header-number">
            <h3>Faktura č. {{$invoice->reference_number}}</h3>
            <h4>Evidenční číslo: {{$invoice->evidence_number}}</h4>
        </td>
    </tr>
</table>

<hr>

<table width="100%">
    <tr class="vertical-align-top">
        <td valign="left" class="invoice-header-delivery" style="width: 30%">
            <h3>Odběratel</h3>
            <p>{{$invoice->invoiceSubscriber->name}}</p>
            <p>{{$invoice->invoiceSubscriber->street}}</p>
        </td>
        <td align="right" style="text-align: center; border: 1px solid">
            <h5>VYSTAVENO</h5>
            <p>{{$invoice->date_of_issue->format('d.m.Y')}}</p>
        </td>
        <td align="right" style="background: #7a7f86; text-align: center; color: white;">
            <h5>CELKEM</h5>
            <p>@money($invoice->invoiceLists->sum('total_price')) Kč</p>
        </td>
        <td align="right" style="text-align: center; border: 1px solid">
            <h5>SPLATNOST</h5>
            <p>{{$invoice->due_date->format('d.m.Y')}}</p>
        </td>
    </tr>
    <tr class="vertical-align-top">
        <td valign="left" class="invoice-header-delivery">
            <p>{{$invoice->invoiceSubscriber->postcode}}, {{$invoice->invoiceSubscriber->city}}</p>
            <p>{{$invoice->invoiceSubscriber->country->name}}</p>
            <br>
            <p>IČO: {{$invoice->invoiceSubscriber->ico}}</p>
            <p>DIČ: {{$invoice->invoiceSubscriber->dic}}</p>
        </td>
        <td></td>
        <td align="right" style="font-size: x-small" class="invoice-header-delivery">
            <br>
            <p>Forma úhrady:</p>
            <p>Variabilní symbol:</p>
            <p>Bankovní účet:</p>
            <p>IBAN/SWITF:</p>
        </td>
        <td align="right" style="font-size: x-small" class="invoice-header-delivery">
            <br>
            <p>{{$invoice->invoice_payment_type}}</p>
            <p>{{$invoice->variable_symbol}}</p>
            <p>{{$invoice->bank_account_number}}</p>
            <p>{{$invoice->iban_account_number}}</p>
        </td>
    </tr>
</table>

<br>
<br>

<table width="100%" style="border-spacing: 10px;">
    <thead style="border-bottom: 2px solid grey;">
    <tr>
        <th style="text-align: center; width: 8%">Počet</th>
        <th style="text-align: left; width: 62%">Popis</th>
        <th style="width: 15%">Jedn. cena </th>
        <th style="width: 15%">Celkem</th>
    </tr>
    </thead>
    <tbody>
    @foreach($invoice->invoiceLists()->get() as $item)
        <tr>
            <td style="text-align: center">{{$item->counter}}</td>
            <td>{{$item->note}}</td>
            <td align="right" style="text-align: center">@money($item->price) Kč</td>
            <td align="right" style="text-align: center">@money($item->total_price) Kč</td>
        </tr>
    @endforeach
    </tbody>

    <tfoot>
    {{--když je dph--}}
    {{--    <tr>--}}
    {{--        <td colspan=""></td>--}}
    {{--        <td align="right">Mezisoučet</td>--}}
    {{--        <td align="right">2 000,00 Kč</td>--}}
    {{--    </tr>--}}
    {{--    <tr>--}}
    {{--        <td colspan="2"></td>--}}
    {{--        <td align="right">DPH 21%</td>--}}
    {{--        <td align="right">2 420,00 Kč</td>--}}
    {{----}}
    {{--    </tr>--}}
    {{--když je dph--}}
    <tr>
        <td colspan="4" align="right"><h4>Celkem k úhradě: <span style="font-size: 20px"> @money($invoice->invoiceLists->sum('total_price')) Kč</span></h4></td>
    </tr>
    <tr>
        <td colspan="4" align="right">
{{--            QR CODE HERE--}}
        </td>
    </tr>
    </tfoot>
</table>


<div style="position: absolute; left: 0; right: 0; bottom: 0; text-align: center; font-size: x-small">
    <p>Fyzická osoba zapsaná v živnostenském rejstříku.</p>
    <p>Fakturu vystavil: www.easy-faktura.cz</p>
</div>

</body>
</html>

resources/views/setting.blade.php
@extends('layouts.page')

@section('title', '| Nastavení')

@section('content')

    <div class="container">
        <div class="text-center mb-4 mt-4">
            <h3 class="font-weight-bolder text-uppercase">Nastavení</h3>
        </div>
        <div id="app" class="card mb-4 border-0 col-md-6 mr-auto ml-auto">
            <div class="card-body">
{{--                @TODO dodělat vue--}}
                {!! Form::open(['method'=>'POST', 'class'=>'row', 'autocomplete' => 'off', 'action' => 'App\Http\Controllers\Pages\SettingPageController@updateSetting']) !!}
                    {!! Honeypot::generate('my_name', 'my_time') !!}
                    <div class="form-group form-group--custom">
                        <label for="name">Jméno <span class="text-danger">*</span></label>
                        <input name="name" type="text" class="form-control" id="name" value="{{$user->name}}" required>
                    </div>
                    <div class="form-group form-group--custom">
{{--                        :class="cinError == null ? 'mb-0' : 'mb-3'"--}}
                        <label for="cin">IČO <span class="text-danger">*</span></label>
{{--                        <div class="w-100">--}}
                            <input name="cin" type="text" class="form-control" id="cin" value="{{$user->ico}}" required>
{{--                            <small v-if="cinError" id="cin" class="form-text text-muted">@{{ cinError }}</small>--}}
{{--                        </div>--}}
                    </div>
                    <div class="form-group form-group--custom">
                        <label for="tin">DIČ</label>
                        <input name="tin" type="text" class="form-control" id="tin" value="{{$user->dic}}">
                    </div>
                    <div class="form-group form-group--custom">
                        <label for="street">Ulice</label>
                        <input name="street" type="text" class="form-control" id="street" value="{{$user->street}}">
                    </div>
                    <div class="form-group form-group--custom">
                        <label for="city">Město</label>
                        <input name="city" type="text" class="form-control" id="city" value="{{$user->city}}">
                    </div>
                    <div class="form-group form-group--custom">
                        <label for="zip">PSČ</label>
                        <input name="zip" type="text" class="form-control" id="zip" value="{{$user->postcode}}">
                    </div>

                    <div class="text-md-right">
                        <button type="submit" class="btn btn-primary">Uložit</button>
                    </div>
                {!! Form::close() !!}
            </div>
        </div>
    </div>

@endsection

@include('includes.script')